package org.greenstone.gsdl3_extension.mat;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;



public class MetadataElement {
    
    protected String metadataName = null;;
    protected int frequency = 0;
    protected ArrayList length = new ArrayList();
    protected HashMap metadataList= new HashMap();
    protected boolean used = false;
    protected HashMap valueList = new HashMap();
    
    public String getMetadataName(){
	return this.metadataName;
    }
    
    public HashMap getValueList(){
	return valueList;
    }
    
    public int getFrequency(){
	return frequency;
    }
    
    public ArrayList getLength(){
	return length;
    }
    
    public HashMap getMetadataList(){
	return metadataList;
    }
        
    public void setMetadataName(String Meta_Name){
	metadataName =  Meta_Name;
    }
    
    public void IncreaseFrequency(){
	frequency++;
    }
    
    public void DecreaseFrequency(){
	frequency--;
    }
    
    public void SetLengthList(int len){
	Integer in = new Integer (len);
	length.add(in);
    }
    
    public void SetmetadataList(String ID, DocumentInfo doc){
	//Integer in = new Integer (num);
	//metadataList.add(in);
	//metadataList = alist;
	metadataList.put(ID, doc);
    }
    
    public void SetStatus(boolean status){
	used = status;
    }
    
    public int[] sortArrayList(){
	
	int[] sortList = new int [metadataList.size()];
	Collection c = metadataList.values();
	Iterator i = c.iterator();
	int x = 0;
	
	while(i.hasNext()){
	    sortList[x] = ((DocumentInfo) i.next()).getFrequence();
	    x++;
	}
	/*
	  for(int i = 0; i < metadataList.size(); i++){
	  sortList[i] = ((Integer)metadataList.get(i)).intValue();
	  }
	*/
	Arrays.sort(sortList);
	return sortList;
    }
}
